import {Component, EventEmitter, Input, Output} from '@angular/core';
import {GameModel} from "../game-model/GameModel";
import {ModelComponent} from "../game-model/ModelComponent";
import {ModelComponentType} from "../game-model/ModelComponentType";
import {ScriptAccount} from "../game-model/scriptAccounts/ScriptAccount";

@Component({
  selector: 'app-editor',
  templateUrl: './editor.component.html',
  styleUrl: './editor.component.scss'
})
export class EditorComponent {
  gameModelComponents: ModelComponent[] = [];
  @Output("onModelNameUpdate") onModelNameUpdateEmitter = new EventEmitter<boolean>();

  openGameModelComponent(gameModelComponent: ModelComponent) {
    if(!this.gameModelComponents.includes(gameModelComponent)) {
      this.gameModelComponents.push(gameModelComponent);
    }
  }

  closeGameModelComponent(gameModelComponent: ModelComponent) {
    this.gameModelComponents = this.gameModelComponents.filter(modelComponent => modelComponent !== gameModelComponent);
  }

  convertModelComponentToScriptAccount(modelComponent: ModelComponent) {
    if(modelComponent instanceof ScriptAccount) {
      return modelComponent as ScriptAccount;
    }
  }

  protected readonly ModelComponentType = ModelComponentType;

  onModelNameUpdate() {
    this.onModelNameUpdateEmitter.emit(true);
  }
}
