import {State} from "./State";

export abstract class Transition<S extends State<any>> {
  startingState: S
  endingState: S


  constructor(startingState: S, endingState: S) {
    this.startingState = startingState;
    this.endingState = endingState;

    this.startingState.addOutgoingTransition(this);
    this.endingState.addIncomingTransition(this);
  }
}
